import sys
#import urllib2
import HTMLParser

# create a subclass and override the handler methods
class WeatherGrab(HTMLParser.HTMLParser):
    def __init__(self):
	HTMLParser.HTMLParser.__init__(self)
	self.intwct=0	#state of grab
	self.dateon=0	#date/column on
	self.current=0
	self.icons={}		# state 2
	self.highs={}		# state 3
	self.lows={}		# state 4
	self.forecasts={}	# state 5

    def handle_starttag(self, tag, attrs):
	if self.intwct == 0:
	    if tag != 'span':
	        return
	    for name, value in attrs:
	        if name == 'class' and value == 'temperature':
	            self.intwct = 1
	        if name == 'tempf': 
		    self.current = value;
	elif self.intwct == 1:
	    if tag == 'div':
	        for name, value in attrs:
	            if name == 'class' and value == 'forecastBody':
	                self.intwct=2
	elif self.intwct == 2:
	    if tag == 'td':
	        for name, value in attrs:
	            if name == 'tempf':
	    		self.highs[self.dateon]=value.strip()
			self.dateon += 1
	    if tag == 'tr':
	        for name, value in attrs:
	            if name == 'class' and value == 'lowRow':
	                self.intwct=3
		        self.dateon=0
	elif self.intwct == 3:
	    if tag == 'td':
	        for name, value in attrs:
	            if name == 'tempf':
	    		self.lows[self.dateon]=value.strip()
			self.dateon += 1

    def handle_endtag(self, tag):
	if self.intwct < 3:
	    return
	if tag != 'tr':
	    return
	self.intwct += 1
	self.dateon=0

    def handle_data(self, data):
	if self.intwct < 4:
	    return
	if self.intwct > 5:
	    return
	data=data.strip()
	if len(data) < 1:
	    return
	if data == 'FORECAST':
	    self.intwct += 1
	    self.dateon=0
	    return
	self.forecasts[self.dateon]=data
	self.dateon += 1

# instantiate the parser and fed it some HTML
parser = WeatherGrab()

#f = urllib2.urlopen('')
f=open(sys.argv[1],'r')
for data in f:
  for line in data.split('\n'):
    if line[0:2] != '<!' and not '(IE)' in line:
        parser.feed(line)

#print p.data
print 'current: ',parser.current
for key,value in parser.icons.iteritems():
    print 'icon',key,': ',value
print 'highs: ',
for key, value in parser.highs.iteritems(): 
    print value,':',
print ''
print 'lows: ',
for key, value in parser.lows.iteritems(): 
    print value,':',
print ''
print 'forcasts: ',len(parser.forecasts)
for key, value in parser.forecasts.iteritems(): 
    print parser.highs[key],'/',parser.lows[key],'  ',value

f.close()
